// ==UserScript==
// @name           nlw_response_log.uc.js
// @namespace      kabeminT
// @description    ぬりかべの投稿履歴をローカルに保存
// @include        main
// @compatibility  Firefox 3.6 4.0
// @author         kabeminT
// @version        2011/04/23 21:00
// ==/UserScript==


function nlwResponseLog(){
	//----------------------------------------//
	//                設定項目                //
	//  投稿履歴を書き込むファイルのフルパス  //
	//        フォルダ区切り文字に注意        //
	//     フォルダは作成しておく必要あり     //
	//----------------------------------------//

	let fullpath = "D:\\nlw\\response.txt";

	//----------------------------------------//
	//              設定ここまで              //
	//----------------------------------------//
	
	let check_button_interval   = 500; //かべの準備ができたか確認する間隔


	//投稿日時を取得して整形
	function getTime (){//{{{
		let now = new Date();
		let year  = now.getYear();
		let month = now.getMonth()+1;
		let day   = now.getDate();
		let hour  = now.getHours();
		let min   = now.getMinutes();
		let sec   = now.getSeconds();

		if(year < 2000) year += 1900;
		if(month<10) month = "0"+month;
		if(day<10)   day   = "0"+day;
		if(hour<10)  hour  = "0"+hour;
		if(min<10)   min   = "0"+min;
		if(sec<10)   sec   = "0"+sec;

		return year+"-"+month+"-"+day+" "+hour+":"+min+":"+sec;
	}//}}}


	//テキストエリアの内容を取得
	function getText (){//{{{
		let text=content.document.getElementById("nlwResponseTextarea").value;
		text = text.replace(/\|/g, "\n");	// | は改行扱い
		return text;
	}//}}}


	//大体のレス番号を取得(書き込み時の最大番号+1)
	function getResNum (){//{{{
		let divin = content.document.getElementById("nlwDivIn");
		let resdiv = divin.getElementsByTagName("div");
		if(resdiv.length<3){
			return 1;
		}
		let tagA = resdiv[resdiv.length-3].getElementsByTagName("a");
		return parseInt(tagA[0].text)+1;
	}//}}}


	//テキストエリアの内容をローカルに保存
	function output_log (){//{{{
		let nsILocalFile = Components.interfaces.nsILocalFile;
		let fp = Components.classes["@mozilla.org/file/local;1"].createInstance(nsILocalFile);
		fp.initWithPath(fullpath);
		try {
			let out = Components.classes['@mozilla.org/network/file-output-stream;1'].createInstance(Components.interfaces.nsIFileOutputStream);
			let conv = Components.classes['@mozilla.org/intl/converter-output-stream;1'].createInstance(Components.interfaces.nsIConverterOutputStream);
			//書込only | ファイルがなければ作成 | ファイルの最後に追記
			out.init(fp, 0x02|0x08|0x10, 0664, 0);	//第3,4引数って何?
			outString =  "----------------------------------------\n";
			outString += "Date  : "+getTime()+"\n";
			outString += "Num   : "+getResNum()+"\n";
			outString += "Title : "+content.document.title+"\n";
			outString += "URL   : "+content.document.location+"\n";
			outString += "\n";
			outString += getText();
			outString += "\n\n";
			conv.init(out, 'UTF-8', 0, 0x0000);
			conv.writeString(outString);
			conv.close();
			out.close();
		} catch(e) {
			alert(e);
		}
	}//}}}


	//Shift+Enterを監視
	function keycheck (e){//{{{
		let keycode = e.which;
		let shift   = typeof e.modifiers == 'undefined' ? e.shiftKey : e.modifiers & Event.SHIFT_MASK;
		if (shift && keycode == 13) {
			output_log();
		}
	}//}}}


	//書き込みボタンにイベント追加
	//アイコン作成
	function initialize (){//{{{
		let elem = content.document.getElementById("nlwResponseLink");
		let textarea = content.document.getElementById('nlwResponseTextarea');

		if(!elem || !textarea) { //書込みボタンが無かったら、見つかるまで2秒間隔で探す
			window.setTimeout(initialize, check_button_interval);
		}
		else{ //書き込みボタンが存在したら、イベントとかを追加していく
			if(!content.document.getElementById("nlwResponseLogPanel")) {

				//イベント登録
				elem.addEventListener('click', output_log, false);
				textarea.addEventListener('keypress', keycheck, false);

				//投稿履歴保存準備が完了したことを知らせるアイコン
				//イベントの2重登録を防ぐためのフラグ的な役割がメイン
				let panel = content.document.createElement("div");
				panel.setAttribute("id", "nlwResponseLogPanel");
				let icon = content.document.createElement("img");
				icon.setAttribute("id", "nlwResponseLogIcon");
				icon.src= 'data:image/png;base64,'+
						'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAAAARnQU1BAACx'+
						'jwv8YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAAAHxJREFU'+
						'OE+VUkkSwCAIK/9/NHWEhi2dVk+CCQmgqOpVj4jH42XnFyGflbAcLh3QYoRnBEMP+a08FYD+RTjr'+
						'odmgxoiltzFYPghzxI6orRACmHmfMe65abbNWLEr5KpWohUqCkBkKBqAsdJ0U6DtBiEbqB+R/YOP'+
						'qT+GALsBdE0u8RQQUVwAAAAASUVORK5CYII=';
				icon.title="投稿履歴保存準備OK";
				panel.appendChild(icon);
				panel.style.display="block";
				panel.style.cssFloat="right";
				panel.style.marginRight="16px";
				content.document.getElementById('nlwDivTool').appendChild(panel);
			}
		}
	}//}}}

	initialize();
}


gBrowser.addEventListener('DOMContentLoaded', nlwResponseLog, false);

// vim: set tabstop=4 shiftwidth=4 softtabstop=4 fdm=marker :
